# Class: oDrawingColumn

## $. oDrawingColumn

oDrawingColumn is a special case of column which can be linked to an oElement. This type of column is used to display drawings and always is visible in the Xsheet window.

#### new $.oDrawingColumn(uniqueName, oAttributeObject)

openHarmony/openHarmony_column.js, line 480
  the $.oDrawingColumn constructor. Only called internally by the factory function scene.getColumnByName();

  Name | Type | Description
  --- | --- | ---
  `uniqueName` | string | The unique name of the column.
  `oAttributeObject` | $.oAttribute | The oAttribute thats connected to the column.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `uniqueName` | string | The unique name of the column.
  `attributeObject` | $.oAttribute | The attribute object that the column is attached to.

### Extends

- $.oColumn

### Members

#### element$.oElement

  Retrieve and set the drawing element attached to the column.

#### readonlyframesArray.<$.oFrame>

  An array of the oFrame objects provided by the column.

#### readonlykeyframesArray.<$.oFrame>

  An array of the keyframes provided by the column.

#### namestring

  The name of the column.

#### selectedbool

  Whether the column is selected.

#### stepSectionobject

  An object with three int values : start, end and step, representing the value of the stepped section parameter (interpolation with non linear "step" parameter).

#### readonlysubColumnsobject

  Provides the available subcolumns, based on the type of the column.

#### readonlytypestring

  The type of the column. There are nine column types: drawing (DRAWING), sound (SOUND), 3D Path (3DPATH), Bezier Curve (BEZIER), Ease Curve (EASE), Expression (EXPR), Timing (TIMING) for timing columns, Quaternion path (QUATERNIONPATH) for 3D rotation and Annotation (ANNOTATION) for annotation columns.

### Methods

#### duplicate(duplicateElement, newAttribute){$.oColumn}

openHarmony/openHarmony_column.js, line 538
  Duplicates a Drawing column.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `duplicateElement` | bool | true | optional Whether to also duplicate the element. Default is true.
  `newAttribute` | $.oAttribute |  | optional Whether to link the new column to an attribute at this point.

  ##### Returns:

  Type | Description
  --- | ---
  $.oColumn | The created column.

#### extendExposures(exposures, amount, replace)

openHarmony/openHarmony_column.js, line 515
  Extends the exposure of the drawing's keyframes given the provided arguments.

  Name | Type | Description
  --- | --- | ---
  `exposures` | Array.<$.oFrame> | The exposures to extend. If UNDEFINED, extends all keyframes.
  `amount` | int | The amount to extend.
  `replace` | bool | Setting this to false will insert frames as opposed to overwrite existing ones.(currently unsupported))

#### inherited getKeyframes(){Array.<$.oFrame>}

openHarmony/openHarmony_column.js, line 367
  Filters out only the keyframes from the frames array.

  ##### Returns:

  Type | Description
  --- | ---
  Array.<$.oFrame> | Provides the array of frames from the column.

#### inherited getKeyFrames(){Array.<$.oFrame>}

openHarmony/openHarmony_column.js, line 394
  Filters out only the keyframes from the frames array.
  Deprecated
    - For case consistency, keyframe will never have a capital F

  ##### Returns:

  Type | Description
  --- | ---
  Array.<$.oFrame> | Provides the array of frames from the column.

#### inherited getValue(frame){various}

openHarmony/openHarmony_column.js, line 405
  Gets the value of the column at the given frame.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `frame` | int | 1 | optional The frame at which to get the value

  ##### Returns:

  Type | Description
  --- | ---
  various | The value of the column, can be different types depending on column type.

#### inherited removeDuplicateKeys()

openHarmony/openHarmony_column.js, line 286
  Removes concurrent/duplicate keys from drawing layers.

#### removeUnexposedDrawings(exposures)

openHarmony/openHarmony_column.js, line 602
  Removes unused drawings from the column.

  Name | Type | Description
  --- | --- | ---
  `exposures` | Array.<$.oFrame> | The exposures to extend. If UNDEFINED, extends all keyframes.

#### renameAllByFrame(prefix, suffix)

openHarmony/openHarmony_column.js, line 568
  Renames the column's exposed drawings according to the frame they are first displayed at.

  Name | Type | Description
  --- | --- | ---
  `prefix` | string | optional a prefix to add to all names.
  `suffix` | string | optional a suffix to add to all names.

#### inherited setValue(newValue, frame)

openHarmony/openHarmony_column.js, line 430
  Sets the value of the column at the given frame.

  Name | Type | Default | Description
  --- | --- | --- | ---
  `newValue` | various |  | The new value to set the column to
  `frame` | int | 1 | optional The frame at which to get the value